

#ifndef USER_IOT_RAM_H_
#define USER_IOT_RAM_H_

#include "debug.h"
#include "ModuleConfig.h"
#include "net_config.h"

#define     MAX_relay     10                        //̵·
#define     HeartBeat_Max_Time   300              //ʱ


#define R32_ESIG_UNIID1        *(__IO u32*)(0x1FFFF7E8);       //Ψһݱ־ֻȡ0-31λ
#define R32_ESIG_UNIID2        *(__IO u32*)(0x1FFFF7EC);       //31-63λ
#define R32_ESIG_UNIID3        *(__IO u32*)(0x1FFFF7F0);       //64-91λ


#define R32_PNG_CR              *(__IO u32*)(0x40023C00 );       // ƼĴ
#define R32_PNG_SR              *(__IO u32*)(0x40023C04 );       //
#define R32_PNG_DR              *(__IO u32*)(0x40023C08 );       //

/******************** 32·̵****************************************/
#define     relay_1_ON()    (  GPIO_SetBits( GPIOA, GPIO_Pin_2 ))
#define     relay_2_ON()    (  GPIO_SetBits( GPIOA, GPIO_Pin_1 ))
#define     relay_3_ON()    (  GPIO_SetBits( GPIOA, GPIO_Pin_0 ))
#define     relay_4_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_3 ))
#define     relay_5_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_2 ))
#define     relay_6_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_1 ))
#define     relay_7_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_0 ))
#define     relay_8_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_15 ))
#define     relay_9_ON()    (  GPIO_SetBits( GPIOC, GPIO_Pin_14 ))
#define     relay_10_ON()   (  GPIO_SetBits( GPIOC, GPIO_Pin_13 ))


/******************** 32·̵ر****************************************/
#define     relay_1_OFF()    (  GPIO_ResetBits( GPIOA, GPIO_Pin_2 ))
#define     relay_2_OFF()    (  GPIO_ResetBits( GPIOA, GPIO_Pin_1 ))
#define     relay_3_OFF()    (  GPIO_ResetBits( GPIOA, GPIO_Pin_0 ))
#define     relay_4_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_3 ))
#define     relay_5_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_2 ))
#define     relay_6_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_1 ))
#define     relay_7_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_0 ))
#define     relay_8_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_15 ))
#define     relay_9_OFF()    (  GPIO_ResetBits( GPIOC, GPIO_Pin_14 ))
#define     relay_10_OFF()   (  GPIO_ResetBits( GPIOC, GPIO_Pin_13 ))

/******************** ȡܽ״̬****************************************/
#define     relay_1            ( GPIO_ReadOutputDataBit( GPIOA, GPIO_Pin_2 ))
#define     relay_2            ( GPIO_ReadOutputDataBit( GPIOA, GPIO_Pin_1 ))
#define     relay_3            ( GPIO_ReadOutputDataBit( GPIOA, GPIO_Pin_0 ))

#define     relay_4            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_3 ))
#define     relay_5            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_2 ))
#define     relay_6            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_1 ))
#define     relay_7            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_0 ))
#define     relay_8            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_15 ))
#define     relay_9            ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_14 ))
#define     relay_10           ( GPIO_ReadOutputDataBit( GPIOC, GPIO_Pin_13 ))

/******************** 32·̵****************************************/
#define     ALL_relay_ON()      ( GPIO_SetBits( GPIOC, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15), GPIO_SetBits( GPIOA, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2) )

/******************** 32·̵ر****************************************/
#define     ALL_relay_OFF()     ( GPIO_ResetBits( GPIOC, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15), GPIO_ResetBits( GPIOA, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2) )

/***************************************************************************************/


extern  u16 DESIP_port;

extern u8 Net_state;
extern u8 MACAddr[6];
extern u8 IPAddr[4];
extern u8 GWIPAddr[4];
extern u8 IPMask[4];
extern u8 DESIP[4];
extern u8 SocketId;
extern u8 SocketRecvBuf[WCHNET_MAX_SOCKET_NUM][RECE_BUF_LEN];
extern u8  brocastIp[4] ;
extern u16 brocastPort ;
extern u16 localPort ;
extern u8 sockFlag;
extern u8 Configbuf[MODULE_CFG_LEN];

extern  u8 Rx_buff[RECE_BUF_LEN];

//extern u32  MCU_ID ;
extern u8  MCU_ID[12];

extern  u8 RUN_State;

extern  u16 Order_number;

extern u8 TX_buff[255];

extern u8 TX_ID;
extern u8 RX_flag;

extern int DCE_OVER_Time;

extern u32 RX_len;


typedef struct
{
    u8 RUN;                      //״̬
    u32 TIMCount;                 //ʱ
    u8 Initstate;                //ʼ״̬
    u8 Endstate;                 //״̬
    u8 RelayState;               //̵״̬
}  TASK_COMPONENTS;


extern TASK_COMPONENTS Task_Comps[MAX_relay];

extern u8 number;
extern u8 number_relay;
extern u16 HeartBeat_Time;


#define  Lock_ON    ( (u8)0x85 )         //״̬
#define  Lock_OFF   ( (u8)0x66 )         //״̬

extern u8 EEPROM_buff[2];

extern  u8 Lock_flag;

#endif
