

#include "User_ETH.h"

__attribute__((aligned(4))) u8 Default_cfg[MODULE_CFG_LEN]= {                    //Module default configuration
    'C','l','o','u','d','_','C','T','_','1','0',0,0,0,0,0,0,0,0,0,0,            //module name
    NET_MODULE_TYPE_TCP_C,                                                          //TCP_C
    192,168,1,150,                                                                //The IP address of the module
    255,255,255,0,                                                               //The subnet mask of the module
    192,168,1,1,                                                                 //The gateway address of the module
    1000%256,1000/256,                                                           //Module source port
    124,221,126,208,                                                                 //destination IP address
    6000%256,6000/256 ,                                                          //destination port
    checkcode1,checkcode2                                                        //Verification code, used to verify configuration information
};


/********************************************************************
 * ƣvoid mStopIfError(u8 iError)
 * Ƿд
 * none
 * 汾V1.0
********************************************************************/
void mStopIfError(u8 iError)
{
    if (iError == WCHNET_ERR_SUCCESS)
        return;
    printf("Error: %02X\r\n", (u16) iError);
}

/********************************************************************
 * ƣvoid WCHNET_UdpServerRecv
 * UDP
 *           socinf - socket information.
 *          ipaddr - IP address
 *          port - port
 *          buf - data buff
 *          len - data length
 * 汾V1.0
********************************************************************/
void WCHNET_UdpServerRecv(struct _SCOK_INF *socinf,u32 ipaddr,u16 port,u8 *buf,u32 len)
{
    u8 i;

    i = ParseConfigbuf(buf) ;
    if(i){
        NVIC_SystemReset();
    }
}

/********************************************************************
 * ƣvoid WCHNET_CreateUdpSocket(void)
 * UDP
 * none
 * 汾V1.0
********************************************************************/
void WCHNET_CreateUdpSocket(void)
{
    u8 i;
    SOCK_INF TmpSocketInf;

    memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));
    TmpSocketInf.SourPort = localPort;
    TmpSocketInf.ProtoType = PROTO_TYPE_UDP;
    TmpSocketInf.RecvStartPoint = (u32)SocketRecvBuf[0];
    TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;
    TmpSocketInf.AppCallBack = WCHNET_UdpServerRecv;
    i = WCHNET_SocketCreat(&SocketId,&TmpSocketInf);
    printf("->·ţ %d\r\n",SocketId);
    mStopIfError(i);
}

/********************************************************************
 * ƣvoid WCHNET_UdpSRecv
 * UDPݻص
 *           socinf - socket information.
 *          ipaddr - IP address
 *          port - port
 *          buf - data buff
 *          len - data length
 * 汾V1.0
********************************************************************/
void WCHNET_UdpSRecv(struct _SCOK_INF *socinf,u32 ipaddr,u16 port,u8 *buf,u32 len)
{
    u8 ip_addr[4],i;

    printf("ip:");
    for(i=0;i<4;i++){
        ip_addr[i] = ipaddr&0xff;
        printf("%-4d",ip_addr[i]);
        ipaddr = ipaddr>>8;
    }

    printf("port=%-8d  len=%-8d  sockeid=%-4d\n",port,len,socinf->SockIndex);
    WCHNET_SocketUdpSendTo(socinf->SockIndex,buf,&len,ip_addr,port);
}


/********************************************************************
 * ƣvoid WCHNET_Create_Communication_Socket(void)
 * 
 * none
 * 汾V1.0
********************************************************************/
void WCHNET_Create_Communication_Socket(void)
{
    u8 i;
    u8 *desip = CFG->dest_ip;
    SOCK_INF TmpSocketInf;

    memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));
    memcpy((void *)TmpSocketInf.IPAddr,desip,4);

    TmpSocketInf.DesPort = ((u16)CFG->dest_port[0]+(u16)CFG->dest_port[1]*256);
    TmpSocketInf.SourPort = ((u16)CFG->src_port[0]+(u16)CFG->src_port[1]*256);
    switch(CFG->type){
     case NET_MODULE_TYPE_TCP_S:
          TmpSocketInf.ProtoType = PROTO_TYPE_TCP;
          sockFlag= NET_MODULE_TYPE_TCP_S;
          break;
     case NET_MODULE_TYPE_TCP_C:
          TmpSocketInf.ProtoType = PROTO_TYPE_TCP;
          sockFlag= NET_MODULE_TYPE_TCP_C;
          break;
     case NET_MODULE_TYPE_UDP_S:
          TmpSocketInf.ProtoType = PROTO_TYPE_UDP;
          TmpSocketInf.AppCallBack = WCHNET_UdpSRecv;
          sockFlag= NET_MODULE_TYPE_UDP_S;
          break;
     case NET_MODULE_TYPE_UDP_C:
          TmpSocketInf.ProtoType = PROTO_TYPE_UDP;
          sockFlag= NET_MODULE_TYPE_UDP_C;
          break;
     default:
          break;
    }
    TmpSocketInf.RecvStartPoint = (u32)SocketRecvBuf[1];
    TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;
    i = WCHNET_SocketCreat(&SocketId,&TmpSocketInf);
    mStopIfError(i);
    switch(CFG->type){
     case NET_MODULE_TYPE_TCP_S:
          WCHNET_SocketListen(SocketId);
          printf("listening\n");
          break;
     case NET_MODULE_TYPE_TCP_C:
          WCHNET_SocketConnect(SocketId);
          printf("->ӳɹ\r\n");
          break;
     default:
          break;
    }
}

/********************************************************************
 * ƣvoid mStopIfError(u8 iError)
 * Ƿд
 * id - socket id.
 * 汾V1.0
********************************************************************/
void WCHNET_DataLoopback(u8 id)
{
    u8 i;
    u32 len;
    u32 endAddr = SocketInf[id].RecvStartPoint + SocketInf[id].RecvBufLen;       //Receive buffer end address

    if ((SocketInf[id].RecvReadPoint + SocketInf[id].RecvRemLen) > endAddr) {    //Calculate the length of the received data
        len = endAddr - SocketInf[id].RecvReadPoint;
    }
    else {
        len = SocketInf[id].RecvRemLen;
    }

    WCHNET_SocketRecv(id, Rx_buff, &len);                                     //Read the data of the receive buffer into MyBuf
    RX_len = len;                                                           //ȡݳ
/*    for(i=0; i<len; i++)
    {
        USART_SendData(USART1,Rx_buff[i]);
        while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
    }
*/
    i = WCHNET_SocketSend(id, (u8 *) SocketInf[id].RecvReadPoint, &len);        //send data

    if (i == WCHNET_ERR_SUCCESS) {
        WCHNET_SocketRecv(id, NULL, &len);                                      //Clear sent data
    }


}

/********************************************************************
 * ƣvoid WCHNET_HandleSockInt(u8 socketid,u8 initstat)
 * Sock ж
 * socketid - socket id
 *       intstat - interrupt status
 * 汾V1.0
********************************************************************/
void WCHNET_HandleSockInt(u8 socketid,u8 initstat)
{

    if(initstat & SINT_STAT_RECV)                                              //receive data
    {
        WCHNET_DataLoopback(socketid);                                         //Data loopback
        RX_flag = 1;                                                           //
    }
    if(initstat & SINT_STAT_CONNECT)                                           //connect successfully
    {
        if(sockFlag == NET_MODULE_TYPE_TCP_S){
          WCHNET_ModifyRecvBuf(socketid,(u32)SocketRecvBuf[socketid],RECE_BUF_LEN);
        }
        printf("->TCP ӳɹ\r\n");
        Net_state = 1;
        TX_ID = socketid;
    }
    if(initstat & SINT_STAT_DISCONNECT)                                        //disconnect
    {
        printf("->TCP ӶϿ\r\n");
        printf("-> \r\n");
        WCHNET_Create_Communication_Socket();
        NVIC_SystemReset();
    }
    if(initstat & SINT_STAT_TIM_OUT)                                           //timeout disconnect
    {
       printf("->TCP ӳʱ\r\n");
       printf("-> \r\n");
       WCHNET_Create_Communication_Socket();
       NVIC_SystemReset();
    }
}

/********************************************************************
 * ƣvoid WCHNET_HandleGlobalInt(void)
 * NETȫж
 * none
 * 汾V1.0
********************************************************************/
void WCHNET_HandleGlobalInt(void)
{
    u8 intstat;
    u8 socketint;
    u16 i;

    intstat = WCHNET_GetGlobalInt();                                           //get global interrupt flag
    if(intstat & GINT_STAT_UNREACH)                                            //Unreachable interrupt
    {
        printf("->ɴж\r\n");
        printf("->  \r\n");
        NVIC_SystemReset();
    }
    if(intstat & GINT_STAT_IP_CONFLI)                                          //IP conflict
    {
        printf("->IP ͻ \r\n");
        printf("->  \r\n");
        NVIC_SystemReset();
    }
    if(intstat & GINT_STAT_PHY_CHANGE)                                         //PHY status change
    {
        i = WCHNET_GetPHYStatus();                                             //socket related interrupt
        if(i&PHY_Linked_Status)
            printf("->PHY ӳɹ\r\n");
        else if (i&PHY_OFF_Status )
        {
             printf("->PHY ӶϿ\r\n");
             NVIC_SystemReset();
        }
    }
    if(intstat & GINT_STAT_SOCKET)
    {
        for(i = 0; i < WCHNET_MAX_SOCKET_NUM; i ++)
        {
            socketint = WCHNET_GetSocketInt(i);
            if(socketint)WCHNET_HandleSockInt(i,socketint);
        }
    }
}

/********************************************************************
 * ƣuser_eth_init()
 * NETʼ
 * none
 * 汾V1.0
********************************************************************/
void user_eth_init()
{
    u8 i;

    memcpy(IPAddr,CFG->src_ip,sizeof(CFG->src_ip));
    memcpy(GWIPAddr,CFG->getway,sizeof(CFG->getway));
    memcpy(IPMask,CFG->mask,sizeof(CFG->mask));
    i = ETH_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                      //Ethernet library initialize
    mStopIfError(i);
    if(i == WCHNET_ERR_SUCCESS) printf("->NETʼɹ\r\n");
    WCHNET_CreateUdpSocket();                                             //Create UDP Socket
    if(CFG->type != NET_MODULE_TYPE_NONE){                                //No mode is enabled by default
        WCHNET_Create_Communication_Socket();                             //Create a socket configured by the host computer
    }
}


